/*
 * generated by Xtext 2.32.0
 */
package no.ntnu.tdt4250.sm.textual.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.CrossReference;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class StateMachineDSLGrammarAccess extends AbstractElementFinder.AbstractGrammarElementFinder {
	
	public class SMElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "no.ntnu.tdt4250.sm.textual.StateMachineDSL.SM");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cStateMachineKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameEStringParserRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cStatesKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Keyword cLeftCurlyBracketKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cStateAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cStateStateParserRuleCall_4_0 = (RuleCall)cStateAssignment_4.eContents().get(0);
		private final Assignment cStateAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cStateStateParserRuleCall_5_0 = (RuleCall)cStateAssignment_5.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_6 = (Keyword)cGroup.eContents().get(6);
		private final Keyword cTransitionsKeyword_7 = (Keyword)cGroup.eContents().get(7);
		private final Keyword cLeftCurlyBracketKeyword_8 = (Keyword)cGroup.eContents().get(8);
		private final Assignment cTransitionAssignment_9 = (Assignment)cGroup.eContents().get(9);
		private final RuleCall cTransitionTransitionParserRuleCall_9_0 = (RuleCall)cTransitionAssignment_9.eContents().get(0);
		private final Assignment cTransitionAssignment_10 = (Assignment)cGroup.eContents().get(10);
		private final RuleCall cTransitionTransitionParserRuleCall_10_0 = (RuleCall)cTransitionAssignment_10.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_11 = (Keyword)cGroup.eContents().get(11);
		private final Keyword cInitialKeyword_12 = (Keyword)cGroup.eContents().get(12);
		private final Assignment cInitialAssignment_13 = (Assignment)cGroup.eContents().get(13);
		private final CrossReference cInitialStateCrossReference_13_0 = (CrossReference)cInitialAssignment_13.eContents().get(0);
		private final RuleCall cInitialStateEStringParserRuleCall_13_0_1 = (RuleCall)cInitialStateCrossReference_13_0.eContents().get(1);
		private final Keyword cFinalKeyword_14 = (Keyword)cGroup.eContents().get(14);
		private final Keyword cLeftParenthesisKeyword_15 = (Keyword)cGroup.eContents().get(15);
		private final Assignment cFinalAssignment_16 = (Assignment)cGroup.eContents().get(16);
		private final CrossReference cFinalStateCrossReference_16_0 = (CrossReference)cFinalAssignment_16.eContents().get(0);
		private final RuleCall cFinalStateEStringParserRuleCall_16_0_1 = (RuleCall)cFinalStateCrossReference_16_0.eContents().get(1);
		private final Group cGroup_17 = (Group)cGroup.eContents().get(17);
		private final Keyword cCommaKeyword_17_0 = (Keyword)cGroup_17.eContents().get(0);
		private final Assignment cFinalAssignment_17_1 = (Assignment)cGroup_17.eContents().get(1);
		private final CrossReference cFinalStateCrossReference_17_1_0 = (CrossReference)cFinalAssignment_17_1.eContents().get(0);
		private final RuleCall cFinalStateEStringParserRuleCall_17_1_0_1 = (RuleCall)cFinalStateCrossReference_17_1_0.eContents().get(1);
		private final Keyword cRightParenthesisKeyword_18 = (Keyword)cGroup.eContents().get(18);
		
		//SM returns StateMachine:
		//    'StateMachine'
		//    name=EString
		//        'states' '{' state+=State ( state+=State)* '}'
		//        'transitions' '{' transition+=Transition ( transition+=Transition)* '}'
		//        'initial' initial=[State|EString]
		//        'final' '(' final+=[State|EString] ( "," final+=[State|EString])* ')'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'StateMachine'
		//name=EString
		//    'states' '{' state+=State ( state+=State)* '}'
		//    'transitions' '{' transition+=Transition ( transition+=Transition)* '}'
		//    'initial' initial=[State|EString]
		//    'final' '(' final+=[State|EString] ( "," final+=[State|EString])* ')'
		public Group getGroup() { return cGroup; }
		
		//'StateMachine'
		public Keyword getStateMachineKeyword_0() { return cStateMachineKeyword_0; }
		
		//name=EString
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//EString
		public RuleCall getNameEStringParserRuleCall_1_0() { return cNameEStringParserRuleCall_1_0; }
		
		//'states'
		public Keyword getStatesKeyword_2() { return cStatesKeyword_2; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_3() { return cLeftCurlyBracketKeyword_3; }
		
		//state+=State
		public Assignment getStateAssignment_4() { return cStateAssignment_4; }
		
		//State
		public RuleCall getStateStateParserRuleCall_4_0() { return cStateStateParserRuleCall_4_0; }
		
		//( state+=State)*
		public Assignment getStateAssignment_5() { return cStateAssignment_5; }
		
		//State
		public RuleCall getStateStateParserRuleCall_5_0() { return cStateStateParserRuleCall_5_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_6() { return cRightCurlyBracketKeyword_6; }
		
		//'transitions'
		public Keyword getTransitionsKeyword_7() { return cTransitionsKeyword_7; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_8() { return cLeftCurlyBracketKeyword_8; }
		
		//transition+=Transition
		public Assignment getTransitionAssignment_9() { return cTransitionAssignment_9; }
		
		//Transition
		public RuleCall getTransitionTransitionParserRuleCall_9_0() { return cTransitionTransitionParserRuleCall_9_0; }
		
		//( transition+=Transition)*
		public Assignment getTransitionAssignment_10() { return cTransitionAssignment_10; }
		
		//Transition
		public RuleCall getTransitionTransitionParserRuleCall_10_0() { return cTransitionTransitionParserRuleCall_10_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_11() { return cRightCurlyBracketKeyword_11; }
		
		//'initial'
		public Keyword getInitialKeyword_12() { return cInitialKeyword_12; }
		
		//initial=[State|EString]
		public Assignment getInitialAssignment_13() { return cInitialAssignment_13; }
		
		//[State|EString]
		public CrossReference getInitialStateCrossReference_13_0() { return cInitialStateCrossReference_13_0; }
		
		//EString
		public RuleCall getInitialStateEStringParserRuleCall_13_0_1() { return cInitialStateEStringParserRuleCall_13_0_1; }
		
		//'final'
		public Keyword getFinalKeyword_14() { return cFinalKeyword_14; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_15() { return cLeftParenthesisKeyword_15; }
		
		//final+=[State|EString]
		public Assignment getFinalAssignment_16() { return cFinalAssignment_16; }
		
		//[State|EString]
		public CrossReference getFinalStateCrossReference_16_0() { return cFinalStateCrossReference_16_0; }
		
		//EString
		public RuleCall getFinalStateEStringParserRuleCall_16_0_1() { return cFinalStateEStringParserRuleCall_16_0_1; }
		
		//( "," final+=[State|EString])*
		public Group getGroup_17() { return cGroup_17; }
		
		//","
		public Keyword getCommaKeyword_17_0() { return cCommaKeyword_17_0; }
		
		//final+=[State|EString]
		public Assignment getFinalAssignment_17_1() { return cFinalAssignment_17_1; }
		
		//[State|EString]
		public CrossReference getFinalStateCrossReference_17_1_0() { return cFinalStateCrossReference_17_1_0; }
		
		//EString
		public RuleCall getFinalStateEStringParserRuleCall_17_1_0_1() { return cFinalStateEStringParserRuleCall_17_1_0_1; }
		
		//')'
		public Keyword getRightParenthesisKeyword_18() { return cRightParenthesisKeyword_18; }
	}
	public class StateElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "no.ntnu.tdt4250.sm.textual.StateMachineDSL.State");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cNameEStringParserRuleCall_0_0 = (RuleCall)cNameAssignment_0.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final Assignment cChildrenAssignment_1_1 = (Assignment)cGroup_1.eContents().get(1);
		private final RuleCall cChildrenStateParserRuleCall_1_1_0 = (RuleCall)cChildrenAssignment_1_1.eContents().get(0);
		private final Group cGroup_1_2 = (Group)cGroup_1.eContents().get(2);
		private final Keyword cCommaKeyword_1_2_0 = (Keyword)cGroup_1_2.eContents().get(0);
		private final Assignment cChildrenAssignment_1_2_1 = (Assignment)cGroup_1_2.eContents().get(1);
		private final RuleCall cChildrenStateParserRuleCall_1_2_1_0 = (RuleCall)cChildrenAssignment_1_2_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_1_3 = (Keyword)cGroup_1.eContents().get(3);
		
		//State:
		//    name=EString
		//    ('{' children+=State ( "," children+=State)* '}' )?
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//name=EString
		//('{' children+=State ( "," children+=State)* '}' )?
		public Group getGroup() { return cGroup; }
		
		//name=EString
		public Assignment getNameAssignment_0() { return cNameAssignment_0; }
		
		//EString
		public RuleCall getNameEStringParserRuleCall_0_0() { return cNameEStringParserRuleCall_0_0; }
		
		//('{' children+=State ( "," children+=State)* '}' )?
		public Group getGroup_1() { return cGroup_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_1_0() { return cLeftCurlyBracketKeyword_1_0; }
		
		//children+=State
		public Assignment getChildrenAssignment_1_1() { return cChildrenAssignment_1_1; }
		
		//State
		public RuleCall getChildrenStateParserRuleCall_1_1_0() { return cChildrenStateParserRuleCall_1_1_0; }
		
		//( "," children+=State)*
		public Group getGroup_1_2() { return cGroup_1_2; }
		
		//","
		public Keyword getCommaKeyword_1_2_0() { return cCommaKeyword_1_2_0; }
		
		//children+=State
		public Assignment getChildrenAssignment_1_2_1() { return cChildrenAssignment_1_2_1; }
		
		//State
		public RuleCall getChildrenStateParserRuleCall_1_2_1_0() { return cChildrenStateParserRuleCall_1_2_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_1_3() { return cRightCurlyBracketKeyword_1_3; }
	}
	public class TransitionElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "no.ntnu.tdt4250.sm.textual.StateMachineDSL.Transition");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cNameEStringParserRuleCall_0_0 = (RuleCall)cNameAssignment_0.eContents().get(0);
		private final Keyword cColonKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cSourceAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final CrossReference cSourceStateCrossReference_2_0 = (CrossReference)cSourceAssignment_2.eContents().get(0);
		private final RuleCall cSourceStateEStringParserRuleCall_2_0_1 = (RuleCall)cSourceStateCrossReference_2_0.eContents().get(1);
		private final Keyword cHyphenMinusHyphenMinusGreaterThanSignKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cTargetAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final CrossReference cTargetStateCrossReference_4_0 = (CrossReference)cTargetAssignment_4.eContents().get(0);
		private final RuleCall cTargetStateEStringParserRuleCall_4_0_1 = (RuleCall)cTargetStateCrossReference_4_0.eContents().get(1);
		
		//Transition:
		//    name=EString ':'
		//    source=[State|EString] '-->' target=[State|EString];
		@Override public ParserRule getRule() { return rule; }
		
		//name=EString ':'
		//source=[State|EString] '-->' target=[State|EString]
		public Group getGroup() { return cGroup; }
		
		//name=EString
		public Assignment getNameAssignment_0() { return cNameAssignment_0; }
		
		//EString
		public RuleCall getNameEStringParserRuleCall_0_0() { return cNameEStringParserRuleCall_0_0; }
		
		//':'
		public Keyword getColonKeyword_1() { return cColonKeyword_1; }
		
		//source=[State|EString]
		public Assignment getSourceAssignment_2() { return cSourceAssignment_2; }
		
		//[State|EString]
		public CrossReference getSourceStateCrossReference_2_0() { return cSourceStateCrossReference_2_0; }
		
		//EString
		public RuleCall getSourceStateEStringParserRuleCall_2_0_1() { return cSourceStateEStringParserRuleCall_2_0_1; }
		
		//'-->'
		public Keyword getHyphenMinusHyphenMinusGreaterThanSignKeyword_3() { return cHyphenMinusHyphenMinusGreaterThanSignKeyword_3; }
		
		//target=[State|EString]
		public Assignment getTargetAssignment_4() { return cTargetAssignment_4; }
		
		//[State|EString]
		public CrossReference getTargetStateCrossReference_4_0() { return cTargetStateCrossReference_4_0; }
		
		//EString
		public RuleCall getTargetStateEStringParserRuleCall_4_0_1() { return cTargetStateEStringParserRuleCall_4_0_1; }
	}
	public class EStringElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "no.ntnu.tdt4250.sm.textual.StateMachineDSL.EString");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cSTRINGTerminalRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cIDTerminalRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//EString returns ecore::EString:
		//    STRING | ID;
		@Override public ParserRule getRule() { return rule; }
		
		//STRING | ID
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//STRING
		public RuleCall getSTRINGTerminalRuleCall_0() { return cSTRINGTerminalRuleCall_0; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_1() { return cIDTerminalRuleCall_1; }
	}
	
	
	private final SMElements pSM;
	private final StateElements pState;
	private final TransitionElements pTransition;
	private final EStringElements pEString;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public StateMachineDSLGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pSM = new SMElements();
		this.pState = new StateElements();
		this.pTransition = new TransitionElements();
		this.pEString = new EStringElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("no.ntnu.tdt4250.sm.textual.StateMachineDSL".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//SM returns StateMachine:
	//    'StateMachine'
	//    name=EString
	//        'states' '{' state+=State ( state+=State)* '}'
	//        'transitions' '{' transition+=Transition ( transition+=Transition)* '}'
	//        'initial' initial=[State|EString]
	//        'final' '(' final+=[State|EString] ( "," final+=[State|EString])* ')'
	//;
	public SMElements getSMAccess() {
		return pSM;
	}
	
	public ParserRule getSMRule() {
		return getSMAccess().getRule();
	}
	
	//State:
	//    name=EString
	//    ('{' children+=State ( "," children+=State)* '}' )?
	//;
	public StateElements getStateAccess() {
		return pState;
	}
	
	public ParserRule getStateRule() {
		return getStateAccess().getRule();
	}
	
	//Transition:
	//    name=EString ':'
	//    source=[State|EString] '-->' target=[State|EString];
	public TransitionElements getTransitionAccess() {
		return pTransition;
	}
	
	public ParserRule getTransitionRule() {
		return getTransitionAccess().getRule();
	}
	
	//EString returns ecore::EString:
	//    STRING | ID;
	public EStringElements getEStringAccess() {
		return pEString;
	}
	
	public ParserRule getEStringRule() {
		return getEStringAccess().getRule();
	}
	
	//terminal ID: '^'?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt: ('0'..'9')+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//            '"' ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|'"') )* '"' |
	//            "'" ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|"'") )* "'"
	//        ;
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT : '/*' -> '*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT : '//' !('\n'|'\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS         : (' '|'\t'|'\r'|'\n')+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER: .;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
